"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// the raw materials
const Clocks = require("./clocks");
class ClockFactory1 {
    constructor() {
        this.clockType = "Clock1";
        this.numcreated = 0;
    }
    instance() {
        this.numcreated++;
        return new Clocks.Clock1;
    }
    numCreated() { return this.numcreated; }
}
class ClockFactory2 {
    constructor() {
        this.clockType = "Clock2";
        this.numcreated = 0;
    }
    instance() {
        this.numcreated++;
        return new Clocks.Clock2;
    }
    numCreated() { return this.numcreated; }
}
class ClockFactory3 {
    constructor() {
        this.clockType = "Clock3";
        this.numcreated = 0;
    }
    instance() {
        this.numcreated++;
        return new Clocks.Clock3;
    }
    numCreated() { return this.numcreated; }
}
// these classes all share some code, so you could make
// an abstract class and have them all inherit from it, 
class GeneralClockFactory {
    constructor() {
        this.numcreated = 0;
    }
    numCreated() { return this.numcreated; }
}
class ClockFactory3asSubclass extends GeneralClockFactory {
    constructor() {
        super(...arguments);
        this.clockType = "Clock3";
    }
    instance() {
        this.numcreated++;
        return new Clocks.Clock3;
    }
}
// choose which of the factories to export, but don't 
// tell anybody which one it is.
exports.default = ClockFactory1;
//# sourceMappingURL=clockFactories.js.map