"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifferentClockClient = exports.ObservedClockClient = exports.ObservedClock = void 0;
class ObservedClock {
    constructor() {
        this.time = 0;
        this.observers = [];
    }
    reset() { this.time = 0; }
    tick() { this.time++; this.notifyAll(); }
    addObserver(obs) { this.observers.push(obs); }
    notifyAll() {
        this.observers.forEach(obs => obs.notify(this.time));
    }
}
exports.ObservedClock = ObservedClock;
class ObservedClockClient {
    constructor(theclock) {
        this.theclock = theclock;
        this.time = 0;
        theclock.addObserver(this);
    }
    notify(t) { this.time = t; }
    getTime() { return this.time; }
}
exports.ObservedClockClient = ObservedClockClient;
// the Observer gets to decide what to do with the notification
class DifferentClockClient {
    constructor(theclock) {
        this.theclock = theclock;
        this.time = 0;
        this.notifications = []; // just for fun
        theclock.addObserver(this);
    }
    notify(t) {
        this.notifications.push(t);
        this.time = t * 2;
    }
    getTime() { return (this.time / 2); }
}
exports.DifferentClockClient = DifferentClockClient;
//# sourceMappingURL=clockWithObserver.js.map