"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const clockWithObserver_1 = require("./clockWithObserver");
describe("tests of observed clock", () => {
    test("single observer", () => {
        const clock1 = new clockWithObserver_1.ObservedClock();
        const observer1 = new clockWithObserver_1.ObservedClockClient(clock1);
        expect(observer1.getTime()).toBe(0);
        clock1.tick();
        clock1.tick();
        expect(observer1.getTime()).toBe(2);
    });
    test("test of DifferentClockClient", () => {
        const clock1 = new clockWithObserver_1.ObservedClock();
        const observer1 = new clockWithObserver_1.DifferentClockClient(clock1);
        expect(observer1.getTime()).toBe(0);
        clock1.tick();
        expect(observer1.getTime()).toBe(1);
        clock1.tick();
        expect(observer1.getTime()).toBe(2);
    });
    test("Multiple Observers", () => {
        const clock1 = new clockWithObserver_1.ObservedClock();
        const observer1 = new clockWithObserver_1.DifferentClockClient(clock1);
        const observer2 = new clockWithObserver_1.ObservedClockClient(clock1);
        const observer3 = new clockWithObserver_1.ObservedClockClient(clock1);
        clock1.tick();
        clock1.tick();
        expect(observer1.getTime()).toBe(2);
        expect(observer2.getTime()).toBe(2);
        expect(observer3.getTime()).toBe(2);
    });
});
//# sourceMappingURL=clockWithObserver.spec.js.map