"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SingletonClockFactory2 = exports.SingletonClockFactory = void 0;
// use whichever clock factory is exported from clockFactories
const clockFactories_1 = require("./clockFactories");
class SingletonClockFactory {
    constructor() { }
    static instance() {
        if (SingletonClockFactory.theClock === undefined) {
            SingletonClockFactory.theClock
                = (new clockFactories_1.default).instance();
        }
        ;
        return SingletonClockFactory.theClock;
    }
}
exports.SingletonClockFactory = SingletonClockFactory;
// the code above depends on the peculiarity that in TS, 
// theClock will be initially undefined.
// here's a solution that doesn't depend on that language property
class SingletonClockFactory2 {
    constructor() { }
    static instance() {
        if (!(SingletonClockFactory2.isInitialized)) {
            SingletonClockFactory2.theClock
                = (new clockFactories_1.default).instance();
            SingletonClockFactory2.isInitialized = true;
        }
        ;
        return SingletonClockFactory2.theClock;
    }
}
exports.SingletonClockFactory2 = SingletonClockFactory2;
SingletonClockFactory2.isInitialized = false;
//# sourceMappingURL=singletonClockFactory.js.map